unit suzutalk;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls;

type
  TSuzuTalk = class
  private
    {=== ᥤեˤ륯饹ؤΥ饹 }
    Screen : TBitmap;
    Obj1 : TBitmap;
    Obj2 : TBitmap;
    Talk : TLabel;
    {=== ݻѿ }
    ScriptNum : Integer;
    ScriptStep : Integer;
    WaitTime : Integer;
    {=== եå᥽å }
    procedure ChrTransAll(num : Integer);
    procedure ChrTrans(num, part : Integer);
    {=== ץȴ᥽å }
  public
    {=== 󥿡եץѥƥ }
    {--- ᥤեؤΥեå񤭴׵ե饰 }
    RefreshFlag : Boolean;
    {--- ץȼ¹ե饰 }
    ScriptFlag : Boolean;
    constructor Create;
    destructor Destroy; override;
    {=== ᥤեफΥ饹Ϥ }
    procedure SetClass(BG, Chr1, Chr2 : TBitmap; Mes : TLabel);
    {=== 󥿡ե᥽å }
    procedure Main;
    procedure StartScript(num : Integer);
  end;


{------------------------------------------------------}
{======= ץȥǡ =============================}
{------------------------------------------------------}
type
  STask = (stEnd, stWait, stMes, stObj1, stObj2);
  TScript = record
    com: STask;
    num: Integer;
  end;

const
  { å }
  TalkMessage : array [0..9] of String = (
                      '椦'#10'礦ФäƤʤ',
                      'Ĥ줵ޤʤ',
                      '줿Ȥ'#10'ǡ򤱤',
                      'ġĤ衢椦',
                      'äơ椦',
                      'Ϥ䤪Ϥ',
                      '',
                      'Ϥ줿ҤϤɤˤǤ',
                      'ʤ',
                      '͡'#10'ؤȤ⤦'
                      );

  { ץ }
  TalkScript1 : array [0..2] of TScript = (
                      (com:stMes; num:0),
                      (com:stWait; num:50),
                      (com:stEnd; num:0)
                      );
  TalkScript2 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:1),
                      (com:stWait; num:50),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript3 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:2),
                      (com:stWait; num:50),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript4 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:3),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript5 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:4),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript6 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:5),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript7 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:6),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript8 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:7),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript9 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:8),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );
  TalkScript10 : array [0..11] of TScript = (
                      (com:stWait; num:5),
                      (com:stObj2; num:0),
                      (com:stObj2; num:1),
                      (com:stObj2; num:2),
                      (com:stObj2; num:3),
                      (com:stMes; num:9),
                      (com:stWait; num:100),
                      (com:stObj1; num:0),
                      (com:stObj1; num:1),
                      (com:stObj1; num:2),
                      (com:stObj1; num:3),
                      (com:stEnd; num:0)
                      );

implementation

{------------------------------------------------------}
{=======  =====================================}
{------------------------------------------------------}

constructor TSuzuTalk.Create;
begin
  inherited Create;
  {-- ä }
  WaitTime := 0;
  ScriptNum := 0;
  ScriptStep := 0;
  ScriptFlag := False;
  RefreshFlag := False;
end;

destructor TSuzuTalk.Destroy;
begin
  {--  }
  inherited Destroy;
end;

procedure TSuzuTalk.SetClass(BG, Chr1, Chr2 : TBitmap; Mes : TLabel);
Begin
  Screen := BG;
  Obj1 := Chr1;
  Obj2 := Chr2;
  Talk := Mes;
end;


{------------------------------------------------------}
{======= ᥤȤΥ󥿡ե ===================}
{------------------------------------------------------}

{=== ץȼ¹ԥᥤ }
procedure TSuzuTalk.Main;
var
  task : STask;
  arg : Integer;
begin
  {--- ưǤʤХ꥿}
  if ScriptFlag = False then Exit;
  {--- Ƚ}
  if WaitTime > 0 then
  begin
    Dec(WaitTime);
    Exit;
  end;
  {--- 1ƥå׼¹ }
  {ץΥƥåɤ߼}
  Case ScriptNum of
    0:
      begin
         task := TalkScript1[ScriptStep].com;
         arg := TalkScript1[ScriptStep].num;
      end;
    1:
      begin
         task := TalkScript2[ScriptStep].com;
         arg := TalkScript2[ScriptStep].num;
      end;
    2:
      begin
         task := TalkScript3[ScriptStep].com;
         arg := TalkScript3[ScriptStep].num;
      end;
    3:
      begin
         task := TalkScript4[ScriptStep].com;
         arg := TalkScript4[ScriptStep].num;
      end;
    4:
      begin
         task := TalkScript5[ScriptStep].com;
         arg := TalkScript5[ScriptStep].num;
      end;
    5:
      begin
         task := TalkScript6[ScriptStep].com;
         arg := TalkScript6[ScriptStep].num;
      end;
    6:
      begin
         task := TalkScript7[ScriptStep].com;
         arg := TalkScript7[ScriptStep].num;
      end;
    7:
      begin
         task := TalkScript8[ScriptStep].com;
         arg := TalkScript8[ScriptStep].num;
      end;
    8:
      begin
         task := TalkScript9[ScriptStep].com;
         arg := TalkScript9[ScriptStep].num;
      end;
    9:
      begin
         task := TalkScript10[ScriptStep].com;
         arg := TalkScript10[ScriptStep].num;
      end;
  end;
  Inc(ScriptStep);
  {ץȤΥޥɼ¹}
  Case task of
    stEnd: ScriptFlag := False;
    stWait: WaitTime := arg;
    stMes:
      begin
        Talk.Caption := TalkMessage[arg];
        RefreshFlag := True;
      end;
    stObj1:
      begin
        ChrTrans(0, arg);
        RefreshFlag := True;
      end;
    stObj2:
      begin
        ChrTrans(1, arg);
        RefreshFlag := True;
      end;
  end;
end;

{=== ץȳϥꥯ }
procedure TSuzuTalk.StartScript(num : Integer);
begin
  ScriptFlag := True;
  ScriptNum := num;
  ScriptStep := 0;
  WaitTime := 0;
  ChrTransAll(0);
  RefreshFlag := True;
  Talk.Caption := '';
end;


{------------------------------------------------------}
{======= եå񤭴᥽å==================}
{------------------------------------------------------}

{=== ̾索֥ž }
procedure TSuzuTalk.ChrTransAll(num : Integer);
var
  source : TBitmap;
  pix1, pix2 : PLongword;
  i, j : Integer;
begin
  {--- ɤž롩}
  case num of
    0 : source := Obj1;
    1 : source := Obj2;
  else
    source := Obj1;
  end;
  {--- ž(٥) }
  for j := 0 to 216 do
  begin
    pix1 := PLongword(Screen.ScanLine[j+43]);
    Inc(pix1, 346);
    pix2 := PLongword(source.ScanLine[j]);
    for i := 0 to 150 do
    begin
      pix1^ := pix2^;
      Inc(pix1);
      Inc(pix2);
    end;
  end;
end;


{=== 磻ץ֥ž }
procedure TSuzuTalk.ChrTrans(num, part : Integer);
var
  source : TBitmap;
  pix1, pix2 : PLongword;
  i, j : Integer;
begin
  {--- ɤž롩}
  case num of
    0 : source := Obj1;
    1 : source := Obj2;
  else
    source := Obj1;
  end;
  {--- ž(٥) }
  for j := 0 to 107 do
  begin
    case part of
      0 : begin
            pix1 := PLongword(Screen.ScanLine[j*2+43]);
            pix2 := PLongword(source.ScanLine[j*2]);
          end;
      1 : begin
            pix1 := PLongword(Screen.ScanLine[j*2+1+43]);
            pix2 := PLongword(source.ScanLine[j*2+1]);
            Inc(pix1);
            Inc(pix2);
          end;
      2 : begin
            pix1 := PLongword(Screen.ScanLine[j*2+43]);
            pix2 := PLongword(source.ScanLine[j*2]);
            Inc(pix1);
            Inc(pix2);
          end;
      3 : begin
            pix1 := PLongword(Screen.ScanLine[j*2+1+43]);
            pix2 := PLongword(source.ScanLine[j*2+1]);
          end;
    end;
    Inc(pix1, 346);
    for i := 0 to 75 do
    begin
      pix1^ := pix2^;
      Inc(pix1);
      Inc(pix2);
      Inc(pix1);
      Inc(pix2);
    end;
  end;
end;


end.
